<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ResourceServerConfiguration.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">astrapay-otp</a> &gt; <a href="index.source.html" class="el_package">com.astrapay.otp.config</a> &gt; <span class="el_source">ResourceServerConfiguration.java</span></div><h1>ResourceServerConfiguration.java</h1><pre class="source lang-java linenums">package com.astrapay.otp.config;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpMethod;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.oauth2.config.annotation.web.configuration.EnableResourceServer;
import org.springframework.security.oauth2.config.annotation.web.configuration.ResourceServerConfigurerAdapter;
import org.springframework.security.oauth2.config.annotation.web.configurers.ResourceServerSecurityConfigurer;
import javax.servlet.ServletContext;

@Configuration
@EnableResourceServer
<span class="fc" id="L17">public class ResourceServerConfiguration extends ResourceServerConfigurerAdapter {</span>
<span class="fc" id="L18">    private static final Logger log = LoggerFactory.getLogger(ResourceServerConfiguration.class);</span>

    private static final String RESOURCE_ID = &quot;resource-server-rest-api&quot;;
    private static final String SECURED_READ_SCOPE = &quot;#oauth2.hasScope('read')&quot;;
    private static final String SECURED_WRITE_SCOPE = &quot;#oauth2.hasScope('write')&quot;;
    private static final String UNSECURED_PATTERN_USER = &quot;/public/**&quot;;
    private static final String SECURED_PATTERN = &quot;/validate/**&quot;;

    @Value(&quot;${service.resource.secured-pattern}&quot;)
    private String securedPattern;

    @Value(&quot;${service.oauth-bearer-token-as-basic-auth}&quot;)
    private boolean enableBearerTokenOnBasicAuth;

    @Autowired
    private ServletContext servletCtx;

    @Override
    public void configure(ResourceServerSecurityConfigurer resources) {
<span class="fc" id="L37">        resources.resourceId(RESOURCE_ID);</span>
<span class="fc" id="L38">    }</span>

    @Override
    public void configure(HttpSecurity http) throws Exception {

<span class="pc bpc" id="L43" title="2 of 4 branches missed.">        if (securedPattern == null || securedPattern.trim().length() == 0) {</span>
<span class="fc" id="L44">            securedPattern = SECURED_PATTERN;</span>
        }
<span class="fc" id="L46">        String ctxPath = servletCtx.getContextPath();</span>
<span class="pc bpc" id="L47" title="1 of 2 branches missed.">        if (&quot;/&quot;.equals(ctxPath)) {</span>
<span class="nc" id="L48">            ctxPath = &quot;&quot;;</span>
        }
<span class="fc" id="L50">        log.info(&quot;Using securedPattern=&quot; + ctxPath + securedPattern);</span>
<span class="pc bpc" id="L51" title="1 of 2 branches missed.">        if (enableBearerTokenOnBasicAuth) {</span>
<span class="fc" id="L52">            http.authorizeRequests()</span>
<span class="fc" id="L53">                    .antMatchers(ctxPath + UNSECURED_PATTERN_USER).permitAll()</span>
<span class="fc" id="L54">                    .antMatchers(ctxPath + &quot;/health&quot;).permitAll()</span>
<span class="fc" id="L55">                    .antMatchers(ctxPath + &quot;/token&quot;).permitAll()</span>
<span class="fc" id="L56">                    .antMatchers(HttpMethod.GET).access(SECURED_READ_SCOPE)</span>
<span class="fc" id="L57">                    .antMatchers(HttpMethod.POST).access(SECURED_WRITE_SCOPE)</span>
<span class="fc" id="L58">                    .antMatchers(ctxPath + securedPattern).authenticated();</span>
        } else {
<span class="nc" id="L60">            http.authorizeRequests()</span>
<span class="nc" id="L61">                    .antMatchers(ctxPath + UNSECURED_PATTERN_USER).permitAll()</span>
<span class="nc" id="L62">                    .antMatchers(ctxPath + &quot;/health&quot;).permitAll()</span>
<span class="nc" id="L63">                    .antMatchers(ctxPath + &quot;/token&quot;).permitAll()</span>
<span class="nc" id="L64">                    .antMatchers(ctxPath + securedPattern).authenticated();</span>
        }

<span class="fc" id="L67">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.5.201910111838</span></div></body></html>